//Create a class for door control device
package DoorControl
import Timer.SimulatedTimer

public class DoorControls {
	int deviceNumbers	
	List doorControls
	def timers
	def sendEvent

	//If we have only one device
	private int id = 40
	private String label = "DoorControl"
	private String displayName = "DoorControl"
	private String doorState = "closed"
	private String doorLatestValue = "closed"

	DoorControls(Closure sendEvent, int deviceNumbers) {
		this.sendEvent = sendEvent
		this.timers = new SimulatedTimer()
		this.deviceNumbers = deviceNumbers
		this.doorControls = []
		for (int i = 0;i < deviceNumbers;i++) {
			doorControls.add(new DoorControl(sendEvent, i+60, label+i.toString(), displayName+i.toString(), this.doorState, this.doorLatestValue))
		}
	}

	//Methods for closures
	def count(Closure Input) {
		doorControls.count(Input)
	}
	def size() {
		doorControls.size()
	}
	def each(Closure Input) {
		doorControls.each(Input)
	}

	//By Apps
	def open() {
		doorControls*.on()
	}

	def open(LinkedHashMap metaData) {
		def task = timers.runAfter(metaData["delay"]) {
			doorControls*.on()
		}
	}

	def close() {
		doorControls*.off()
	}

	def close(LinkedHashMap metaData) {
		def task = timers.runAfter(metaData["delay"]) {
			doorControls*.off()
		}
	}

	//By Model Checker
	def setValue(LinkedHashMap eventDataMap) {
		doorControls[eventDataMap["deviceId"]].setValue(eventDataMap["value"])
		if (deviceNumbers == 1)
			this.doorState = doorControls[eventDataMap["deviceId"]].doorState
		sendEvent(eventDataMap)
	}


	def currentValue(String deviceFeature) {
		if (deviceNumbers == 1)
			doorControls[0].currentValue(deviceFeature)
		else
			doorControls*.currentValue(deviceFeature)
	}

	def latestValue(String deviceFeature) {
		if (deviceNumbers == 1)
			doorControls[0].latestValue(deviceFeature)
		else
			doorControls*.latestValue(deviceFeature)
	}

	def getAt(int ix) {
		doorControls[ix]
	}
}
