//Create a class for lock device
package Lock
import Timer.SimulatedTimer

public class Locks{
	int deviceNumbers	
	List locks	
	def sendEvent	
	def timers

	//When we have only one device
	private int id = 20
	private String label = "lock"
	private String displayName = "lock"
	private String lockState = "locked"
	private String currentLock = "locked"
	private String lockLatestValue = "locked"

	Locks(Closure sendEvent, int deviceNumbers) {
		this.sendEvent = sendEvent
		this.timers = new SimulatedTimer()
		this.deviceNumbers = deviceNumbers
		this.locks = []
		for (int i = 0;i < deviceNumbers;i++) {
			locks.add(new Lock(sendEvent, i+20, label+i.toString(), displayName+i.toString(), this.lockState, this.lockLatestValue))
		}
	}

	//By Apps
	def lock() {
		locks*.lock()
	}

	def lock(LinkedHashMap metaData) {
		def task = timers.runAfter(metaData["delay"]) {
			locks*.lock()
		}
	}

	def unlock() {
		locks*.unlock()
	}


	def unlock(LinkedHashMap metaData) {
		def task = timers.runAfter(metaData["delay"]) {
			locks*.unlock()
		}
	}

	//Methods for closures
	def count(Closure Input) {
		locks.count(Input)
	}
	def size() {
		locks.size()
	}
	def each(Closure Input) {
		locks.each(Input)
	}

	//By Model Checker
	def setValue(LinkedHashMap eventDataMap) {
		locks[eventDataMap["deviceId"]].setValue(eventDataMap["value"])
		if (deviceNumbers == 1)
			this.lockState = locks[eventDataMap["deviceId"]].lockState
			this.currentLock = locks[eventDataMap["deviceId"]].lockState
			this.lockLatestValue = locks[eventDataMap["deviceId"]].lockLatestValue
		sendEvent(eventDataMap)
	}

	def currentValue(String deviceFeature) {
		if (deviceNumbers == 1) 
			locks[0].currentValue(deviceFeature)
		else 
			locks*.currentValue(deviceFeature)
	}

	def latestValue(String deviceFeature) {
		if (deviceNumbers == 1)
			locks[0].latestValue(deviceFeature)
		else
			locks*.latestValue(deviceFeature)
	}

	def getAt(int ix) {
		locks[ix]
	}
}

