//Create a class for presence sensor
package PresenceSensor
import Timer.SimulatedTimer

public class PresenceSensors {
	private int deviceNumbers
	private List presenceSensors
	def sendEvent

	//For one device(We cannot have obj.id)-> We should have obj[0].id
	private int id = 0
	private String label = "presenceSensor"
	private String displayName = "presenceSensor"
	private String presenceState = "not present"
	private String currentPresence = "not present"
	private String presenceLatestValue = "not present"

		
	PresenceSensors(Closure sendEvent, int deviceNumbers) {
		this.sendEvent = sendEvent		
		this.deviceNumbers = deviceNumbers
		this.presenceSensors = []

		for (int i = 0;i < deviceNumbers;i++) {
			presenceSensors.add(new PresenceSensor(i+30, label+i.toString(), displayName+i.toString(), this.presenceState, this.presenceLatestValue))
		}
	}

	//By Model Checker
	def setValue(LinkedHashMap eventDataMap) {
		presenceSensors[eventDataMap["deviceId"]].setValue(eventDataMap["value"])
		if (deviceNumbers == 1)
			this.presenceLatestValue = presenceSensors[eventDataMap["deviceId"]].presenceLatestValue
			this.presenceState = presenceSensors[eventDataMap["deviceId"]].presenceState
			this.currentPresence = presenceSensors[eventDataMap["deviceId"]].presenceState
		sendEvent(eventDataMap)
	}

	//Methods for closures
	def count(Closure Input) {
		presenceSensors.count(Input)
	}
	def size() {
		presenceSensors.size()
	}
	def each(Closure Input) {
		presenceSensors.each(Input)
	}


	def currentValue(String deviceFeature) {
		if (deviceNumbers == 1)
			presenceSensors[0].currentValue(deviceFeature)//It is called if we have only one device
		else
			presenceSensors*.currentValue(deviceFeature)
	}

	def latestValue(String deviceFeature) {
		if (deviceNumbers == 1)
			presenceSensors[0].latestValue(deviceFeature)//It is called if we have only one device
		else
			presenceSensors*.latestValue(deviceFeature)
	}

	def getAt(int ix) {
		presenceSensors[ix]
	}
}
